<?PHP

/***
 #=============================================================================
 # PHP Gästebuch von Thomas (VoiD) Keitel
 # (c) 2004
 # (c) 2015
 #
 # Homepage: http://www.unreal-mars.de
 #
 # EMail: ut.void@gmx.de
 #
 # Version
 # 1.2 / 11.09.2004
 # 4.0 / 25.07.2015
 #     / Adaption für XCMS (void-web.de)
 #     / Tabellenname als Konstante GB_TABLENAME
 #-----------------------------------------------------------------------------
 # Das Gästebuch kann frei verwendet werden, solange der "Hinweis", der am
 # unteren Ende der Seite angezeigt wird, nicht entfernt oder verändert wird.
 #=============================================================================
***/

error_reporting(0);

/***
 #==============================================================================
 #
 # BEGINN der Konfiguration ====================================================
 #
 #==============================================================================
***/



$gb_gv_configuration = array
( 'mysql_host'            => '127.0.0.1'
, 'mysql_port'            => 3306
, 'mysql_user'            => 'user'
, 'mysql_pw'              => 'password'
, 'mysql_dbname'          => 'database'
, 'mysql_init'            => 'SET NAMES utf8'
, 'tablename'             => 'vw_guestbook'
, 'mail_sender'           => 'guestbook@void-web.de'
, 'mail_to'               => "ut.void@gmx.de"
, 'mail_cc'               => ""
, 'mail_static_server'    => "http://www.yourdomain"
, 'mail_static_link'      => null
, 'xmail_info_admin'      => true
, 'xmail_info_user'       => true
, 'mail_static_guestbook' => "VoiD's Gästebuch"
, 'mail_static_webmaster' => "admin@void-web.de"
, 'adm_name'              => "test"
, 'adm_pw'                => "test"
, 'images'                => '/images/guestbook'
, 'headline'              => 'Gästebuch'
, 'headline_add'          => 'Herzlich willkommen'
, 'addpost_top_on'        => false
, 'addpost_top_image'     => "#images#/guestbook-arrow-down.bmp"
, 'addpost_bottom_image'  => "#images#/guestbook-arrow-up.bmp"
, 'addpost_bottom_on'     => true
, 'is_html'               => true
, 'css'                   => 'guestbook40.css'
);



define("GB_MAIL_MESSAGE",
   "Hallo,\n"
	."auf Ihren Beitrag in ##MAIL_STATIC_GUESTBOOK## ist eine Antwort eingegangen.\n"
	."\n"
	."Sie erhalten diese eMail nur, weil Sie der unmittelbare Vorposter\n"
	."sind. Sie erhalten aufgrund dieses Posts keine weiteren eMails.\n"
	."\n"
	."##POST_NAME## antwortete:\n"
	."==================================================\n"
	."##POST_MESSAGE##\n"
	."==================================================\n"
	."\n"
	."Sie erreichen das Gästebuch mit diesem Link:\n"
	."##MAIL_DYN_SERVER####MAIL_DYN_LINK##\n"
	."\n"
	."Mit freundlichem Gruß\n"
	."##MAIL_STATIC_WEBMASTER##\n"
);


define("GB_MAIL_INFO_MESSAGE",
   "Neuer Eintrag in Ihrem Gästebuch ##MAIL_STATIC_GUESTBOOK##:\n"
	."\n"
	."==================================================\n"
	."\n"
	."Name: ##POST_NAME##\n"
	."Zeit: ##POST_DATE##\n"
	."eMail: ##POST_MAIL##\n"
	."Homepage: ##POST_HOMEPAGE##\n"
	."IP: ##POST_IP##\n"
	."--------------------------------------------------\n"
	."##POST_MESSAGE##\n"
	."==================================================\n"
	."\n"
	."\n"
	."Sie erreichen Ihr Gästebuch unter:\n"
	."##MAIL_DYN_SERVER####MAIL_DYN_LINK##\n"
	."\n"
	."\n"
	."------\n"
	."Dies ist eine automatisch erzeugte Mail, die bei jedem neuen Eintrag\n"
	."in ihr Gästebuch versandt wurde. Möchten Sie keine weiteren\n"
	."Benachrichtigungsmails erhalten, ändern die bitte den Konfigurations-\n"
	."wert [mail_info_admin]\n"
);


/***
 #=============================================================================
 #
 # ENDE der Konfiguration =====================================================
 #
 #=============================================================================
***/

global $page;

// $page->css_code( $gp_css_styles );

$gb_guestbook = new XVW_Guestbook( $gb_gv_configuration );
$gb_guestbook->main();

echo $gb_guestbook->getContent();
return;

/***
 #=============================================================================
 #
 # Class "Gästebuch"
 #
 #=============================================================================
***/


class XVW_Guestbook {

	/***
	 # Default-Konfiguration
	 #
	 # Mit "!" gekennzeichnete Werte müssen geprüft und gegebenenfalls mittels
	 # << p_config >> beim Konstruktoraufruf überschrieben werden
	***/
	var $config = array
	( 'on'                      => true                                                 //   Gästebuch aktiv?
	, 'edit'                    => true                                                 //   neue Einträge möglich
	, 'mysql_host'              => "localhost"                                          // ! DB-Host
	, 'mysql_port'              => 3306                                                 // ! DB-Port
	, 'mysql_user'              => "SCOTT"                                              // ! DB-Benutzer
	, 'mysql_pw'                => "TIGER"                                              // ! Passwort
	, 'mysql_dbname'            => null                                                 // ! "Datenbank"
  , 'mysql_init'              => null                                                 //   "initiale" Befehle für jeden "connect" (z.B. "SET NAMES utf8")
	, 'tablename'               => "vw_guestbook"                                       // ! Name der Gästebuch-Tabelle
	, 'mail_sender'             => "guestbook@domain.tld"                               // ! Absender
	, 'mail_to'                 => "recipient@domain.tld"                               // ! Mailadresse für interne Benachrichtigung
	, 'mail_cc'                 => ""                                                   //   für nachrichtliche Benachrichtigungen
	, 'mail_static_server'      => "http://www.domain.tld"                              // ! statische Server-Adresse für Mailausgabe
	, 'mail_static_link'        => "/guestbook40.php"                                   // ! statischer Link für Mail-Benachrichtigung
	, 'mail_info_admin'         => false                                                //   Admin über neuen Eintrag benachrichtigen
	, 'mail_info_user'          => false                                                //   "Benutzer/Vorgänger" über neuen Eintrag benachrichtigen
	, 'mail_debug'              => false                                                //   "Mail" anzeigen
	, 'mail_static_guestbook'   => "Guestbook"                                          // ! statischer Name des Gästebuchs
	, 'mail_static_webmaster'   => "webmaster@domain.tld"                               // ! statischer Webmaster Name
	, 'adm_name'                => "test"                                               // ! Name des Administrators...
	, 'adm_pw'                  => "test"                                               // ! ...und zugehöriges Passwort
	, 'images'                  => "/images/guestbook"                                  //   wo sind die Images ? kann in "addpost" / "addpost1" verwendet werden
	, 'external_params'         => null                                                 //   "externe" Parameter
	, 'headline'                => "Gästebuch"                                          //   Überschrift
	, 'headline_add'            => "Herzlich willkommen"                                //   Überschrift Zusatz
	, 'allowed_tags'            => "<b><i><u><a><blockquote>"                           //   erlaubte HTML-Tags
	, 'quote_start'             => "<blockquote><b>Zitat:</b><hr><font color=blue><b>"  //   Beginn Zitat
	, 'quote_end'               => "</b></font><hr></blockquote>"                       //   Ende Zitat
	, 'perpage'                 => 10                                                   //   Anzahl der Posts je Seite
	, 'navigation_range'        => 2                                                    //   Anzahl der Seiten vor/nach in der Navigationsleiste
	, 'addpost_top_on'          => true                                                 //   Link oberhalb des Gästebuchs darstellen
	, 'addpost_top_image'       => "/images/guestbook/guestbook-arrow-down.bmp"         //   Image für Link "oben"
	, 'addpost_top_linktext'    => "Eintrag hinzufügen"                                 //   Link-Text
	, 'addpost_bottom_on'       => true                                                 //   Link unterhalb des Gästebuchs darstellen
	, 'addpost_bottom_image'    => "/images/guestbook/guestbook1-arrow-up.bmp"          //   Image für Link "unten"
	, 'addpost_bottom_linktext' => "Eintrag hinzufügen"                                 //   Link-Text
	, 'max_post_length'         => 2048                                                 //   maximale Post-Länge
	, 'is_html'                 => true                                                 // ! Seite ist eigenständige HTML-Seite
	, 'phpself'                 => null                                                 //   Seite selbst
	, 'ip_delete_after'         => 30                                                   //   IP-Adresse löschen, wenn die Nachricht älter als <Wert> Tage ist
	, 'css'                     => '/guestbook40.css'                                   //   CSS-Datei
	);



	// var $config = array();
	// var $style  = array();
	var $rt     = array();

  var $content = "";
  var $css     = "";
  var $js      = "";


	//---------------------------------------------------------------------------
	function __construct( $p_config )
	//---------------------------------------------------------------------------
  {

		// muss (leider) speziell gesetzt werden
		$this->config['phpself'] = $_SERVER["PHP_SELF"];

		// default-Konfiguration überschreiben / erweitern
	  //---------------------------------
		if ( is_array($p_config) == true ) {
			foreach($p_config as $k => $v) {
				$this->config[$k] = $v;
			}
		}



    $this->css    = file_get_contents( $this->config['css'] , true );

    if(!defined("CRLF"))              define("CRLF"              , PHP_EOL);
    if(!defined("GUESTBOOK_VERSION")) define("GUESTBOOK_VERSION" , "V4.0 <b>::</b> 25.07.2015");
    if(!defined("GB_TABLENAME"))      define("GB_TABLENAME"      , $this->config['tablename']);



	  // PH in den Array ersetzen
	  //---------------------------------
	  foreach( $this->config as $k => $v) {
	  	if ( is_string($v) and stripos('#images#', $v) >= 0  ) {
	  		$this->config[$k] = str_replace('#images#', $this->config['images'], $v);
	  	}
	  }

		// System-Check (Admin Name + Passwort gesetzt?)
	  //---------------------------------
		if(    array_key_exists( 'adm_name' , $this->config) == false
		   or  is_null($this->config['adm_name'])
		   or  strlen($this->config['adm_name']) == 0
		   or  array_key_exists( 'adm_pw' , $this->config) == false
		   or  is_null($this->config['adm_pw'])
		   or  strlen($this->config['adm_pw']) == 0
		  )
		{
			throw new Exception('Admin Informationen unvollständig gesetzt.');
		}

		// "test" / "test" als Logindaten?
		if ( strcasecmp($this->config['adm_name'],"test") == 0 and strcasecmp($this->config['adm_pw'],"test") == 0 ) {
			throw new Exception('Invalid login credentials: test / test');
		}


	  // ein paar "Laufzeit" /Runtime Variablen definieren
	  //---------------------------------
	  $this->rt = array
	  ( 'bg_counter' =>  0
		, 'is_admin'   => false
		, 'mode'       => ""
		, 'adm-md5'    => md5( $this->config['adm_name']
                          .$this->config['adm_pw']
                          .session_id()
                         )
    , 'connection' => null
    );


	  // DB-Verbindung etablieren
	  //---------------------------------
		$this->rt['connection'] = new mysqli
		(	$this->config['mysql_host']
		,	$this->config['mysql_user']
		, $this->config['mysql_pw']
		, $this->config['mysql_dbname']
		, $this->config['mysql_port']
		);

		if ($this->rt['connection']->connect_error) {
      die('Connect Error (' . $mysqli->connect_errno . ') '. $mysqli->connect_error);
    }

    // initiale Befehle an die Datenbank absenden ?!
    //---------------------------------
    if ( is_null($this->config['mysql_init']) == false ) {
      if ( is_string( $this->config['mysql_init'] ) == true ) {
        $this->dbQuery($this->config['mysql_init']);
      }
      else if (is_array($this->config['mysql_init']) == true) {
        foreach($this->config['mysql_init'] as $c) {
          $this->dbQuery( $c );
        }
      }
    }


  }  // -- eof ( __construct ) -- //


	//---------------------------------------------------------------------------
	function __destruct()
	//---------------------------------------------------------------------------
	{

	  // DB-Verbindung trennen
	  //---------------------------------
		if (    (is_null($this->rt['connection']) == false)
		    and (is_object($this->rt['connection'])== true)
		   )
		{
			$this->rt['connection']->close();
			$this->rt['connection']  = null;
		}


  }  // -- eof ( __destruct ) -- //


	//---------------------------------------------------------------------------
  public function getContent()
	//---------------------------------------------------------------------------
  {
    return $this->content;
  }

	//---------------------------------------------------------------------------
  public function getJS()
	//---------------------------------------------------------------------------
  {
    return $this->js;
  }

	//---------------------------------------------------------------------------
  public function getCSS()
	//---------------------------------------------------------------------------
  {
    return $this->css;
  }


	//---------------------------------------------------------------------------
	public function main()
	//---------------------------------------------------------------------------
	{
		$html = "";

		// Gästebuch überhaupt aktiviert ?
		$on   = (array_key_exists('on',   $this->config) ? $this->config['on']   : false);

		// Eintragungen möglich
		$edit = (array_key_exists('edit', $this->config) ? $this->config['edit'] : false);

		if ( !$on ) {
  		// 3. HTML "öffnen"
  		$html .= $this->html_open();
  		$html .= $this->html_guestbook_offline();
  		$html .= $this->html_close();
  		return $html;
		}

		// ADMIN ?
		$this->check_is_admin();
		if ( $this->rt['is_admin'] ) {
		  $edit = true;     // Admin erhält "edit" Berechtigung
		}

		// 3. HTML "öffnen"
		$html .= $this->html_open();


		// 4. Ausgewählte Aktion ausführen
	  if ( $edit ) {
  		$gbAction = strtoupper($this->gbFind('gbaction','SHOW'));

  		if     ($gbAction=="UPDATE" and $this->rt['is_admin']==true) $html .= $this->updatePostInDB();
  		else if($gbAction=="DELETE" and $this->rt['is_admin']==true) $html .= $this->deletePostInDB();
  		else ;

  		if($gbAction=="ADDPOST") {
  		  $html .= $this->show_EditPostForm();
  		}
  		else if (    ($this->rt['is_admin']==true)
  		         and ($gbAction=="ADMIN"  or $gbAction=="UPDATE"  or $gbAction=="DELETE")
  		        )
  		{
		    $html .= $this->adminGuestbook();
  		}
  		else if($gbAction=="EINTRAGEN") {
		    $html .= $this->insertPostInDB();

		    if ( $this->rt['inserted'] == true ) {
       	  $html .= $this->showGuestbook();
       	}
       	else {
      		$html .= $this->previewPost( false );
       	}

     	}
  		else if($gbAction=="VORSCHAU") {
    		$html .= $this->previewPost( true );
  		}
  		else {
     	  $html .= $this->showGuestbook();
  		}
  	}
  	else {
   	  $html .= $this->showGuestbook();
  	}


		// 5. HTML "schliessen"
		$html .= $this->html_close();


		// 6. Sicherstellen, dass kein weiterer PHP Code ausgeführt wird
	  $this->content = $html;

	}  // -- eof ( main ) -- //


	private function check_is_admin()
	{

		//  Prüfen, ob der Benutzer den Admin Namen und das Admin-PW als Parameter
		//  mitangegeben hat
		if($this->gbFind('admName')==$this->config['adm_name'] and $this->gbFind('admPW')==$this->config['adm_pw']) {
		  $parms = array();
		  foreach( $_GET as $k => $v) {
		    if (strcasecmp("admName", $k) == true  or strcasecmp("admPW", $k) == true) {
		      ;
		    }
		    else {
		      $parms[$k] = $v;
		    }
		  }

		  $parms['gbaction'] = "ADMIN";
		  $parms['admMD5']   = $this->rt['adm-md5'];

		  $href= $this->getHREF($parms);

		  if ( headers_sent() == false ) {
		    header("Location: ".$href);
		    exit();
		  }
		  else {
		    echo "<a href=\"".$href."\"><code>Login: ".$href."</code></a><br>";
		    exit();
		  }
		}

		// Prüfen ob der codierte Adminlogin angegeben ist
		if (strlen($this->gbFind('admMD5'))==strlen($this->rt['adm-md5']) and strcmp($this->gbFind('admMD5'), $this->rt['adm-md5']) == 0) {
			$this->rt['is_admin'] = true;
		}

	}  // -- eof ( check_is_admin ) -- //


	#==============================================================================
	#
	# Gästebuch ENDE
	#
	#==============================================================================




	// --- Steuerung der einzelnen 'Modi'

	// EINGABE
	private function show_EditPostForm() {
		$this->rt['mode'] = "ADDPOST";

		$html = "";

		$html .= $this->openForm();

		$gbName     = $this->gbFind('gbName');
		$gbMail     = $this->gbFind('gbMail');
		$gbHomepage = $this->gbFind('gbHomepage');
		$gbMessage  = $this->gbFind('gbMessage');


		$html .= $this->open_Edit_Table();
		$html .= $this->show_Edit_Main("VDGUESTBOOK",0,0,$gbName,$gbMail,$gbHomepage,$gbMessage,NULL);
		$html .= $this->close_Edit_Table();

		$html .= $this->showButtons();

		$html .= $this->closeForm();

		return $html;
	}  // -- end of function show_EditPostForm()





	// POST in DB einfügen
	private function insertPostInDB()
	{
	  $html = "";

		$this->rt['mode']     = "DB_INSERT";
		$this->rt['inserted'] = false;

  	$gbID       = null;
		$gbName     = $this->gbFind('gbName','');
  	$gbWhen     = null;
		$gbMail     = $this->gbFind('gbMail','');
		$gbHomepage = $this->gbFind('gbHomepage','');
  	$gbIP       = null;
		$gbMessage  = $this->gbFind('gbMessage','');

		// auf fehlerhafte Eingabe prüfen
		$error = $this->checkData($gbName,$gbMail,$gbHomepage,$gbMessage);

		// es ist mindestens ein Fehler aufgetreten
		if($error<>"") {
			$html .= $this->showErrMsg($error) . "<br>\n";
			// $html .= $this->show_EditPostForm();
		}

		else {
			// Eingaben "anpassen"
			$gbName     = strip_tags($gbName);
			$gbMail     = strip_tags($gbMail);
			$gbHomepage = strip_tags($gbHomepage);
			$gbMessage  = strip_tags($gbMessage,$this->config['allowed_tags']);

			$gbName     = $this->html2db($gbName);
			$gbMail     = $this->html2db($gbMail);
			$gbHomepage = $this->html2db($gbHomepage);
			$gbMessage  = $this->html2db($gbMessage);

			// Zitate extra formatieren
			$gbMessage = str_replace("<blockquote>",$this->config['quote_start'],$gbMessage);
			$gbMessage = str_replace("</blockquote>",$this->config['quote_end'],$gbMessage);

			// Datensatz in Tabelle einfügen
			$maxgbid = $this->getMaxGbID();

			$alreadyInserted = 0;    // Datensatz noch nicht in der DB
			$rs = $this->dbQuery("SELECT gbName, gbMessage FROM ".GB_TABLENAME." WHERE gbID=".$maxgbid);

			if($rs<>false and $rs->num_rows>0) {
				$arr = $rs->fetch_array(MYSQLI_ASSOC);

				// Dummies, wegen Maskierungszeichen
				$dy_name    = $gbName;
				$dy_message = $gbMessage;

				// Ansonsten (heisst bis auf Maskierungszeichen) identisch?
				if(strcasecmp($arr['gbName'],$dy_name)==0	and strcasecmp($arr['gbMessage'],$dy_message)==0) {
					$alreadyInserted = 1;
				}
			}

			$id     = 0;
			$gbWhen = time();
			$gbIP   = $this->getUserIP();
			// Datensatz nur einmal in die DB einfügen
			if($alreadyInserted == 0) {
				$query = "INSERT INTO ".GB_TABLENAME." SET"
					."  gbID       = ".($maxgbid+1)
					.", gbWhen     = ".((!empty($gbWhen)    ) ? $this->dbMes($gbWhen)             : "NULL")
					.", gbName     = ".((!empty($gbName)    ) ? "'".$this->dbMes($gbName)."'"     : "NULL")
					.", gbEMail    = ".((!empty($gbEMail)   ) ? "'".$this->dbMes($gbEMail)."'"    : "NULL")
					.", gbHomepage = ".((!empty($gbHomepage)) ? "'".$this->dbMes($gbHomepage)."'" : "NULL")
					.", gbMessage  = ".((!empty($gbMessage) ) ? "'".$this->dbMes($gbMessage)."'"  : "NULL")
					.", gbIP       = ".((!empty($gbIP)      ) ? "'".$this->dbMes($gbIP)."'"       : "NULL")
				;

				$id = $this->dbInsert($query);
			}

			// Fehler beim Einfügen des Datensatzes aufgetreten
			if($id==0) {
				$message = ''
				  .'Der Post konnte nicht eingefügt werden. Die Ursache dafür'
					.' könnte eine der folgenden sein:<br>'
					.'<b>&raquo;</b> der Post ist bereits eingefügt<br>'
					.'<b>&raquo;</b> die Verbindung zur Datenbank konnte nicht hergestellt'
					.' werden<br>'
					.'<b>&raquo;</b> es existiert von diesem Autor bereits ein solcher'
					.' Post (identischer Autor und Wortlaut)<br>'
				;

				$html .= $this->showErrMsg($message) . '<br>' . CRLF;

			}

			// Mail versenden
			else {
			  $gbID = $id;
    		$this->rt['inserted'] = true;

			  if ( $this->config['mail_info_admin'] == true and strcmp($this->config['mail_sender'],"")<>0) {

  				$subject = "Neuer Gästebucheintrag ".@$_SERVER['HTTP_HOST'];

          $message = $this->insertPost_getMessage
          ( GB_MAIL_INFO_MESSAGE
          , $id
          , $gbName
          , $gbWhen
          , $gbMail
          , $gbHomepage
          , $gbIP
          , $gbMessage
          );


  				// e-Mail versenden
  				// ! debug      => Mail nur anzeigen   <=> kein Versenden
  				// ! kein debug => Mail nicht anzeigen <=> Mail versenden
  				if ($this->config['mail_debug'] == true) {
  				  $html .= ""
  				    ."<pre style=\"margin: 8px; padding: 8px; color: black; background-color:white; text-align:left; border: solid 1px black;\">"
  				    . "<b>To:</b> " . $this->config['mail_to'] . "<br>"
  				    . "<b>CC:</b> " . ((strcmp($this->config['mail_cc'],"")<>0) ? $this->config['mail_cc'] : "") . "<br>"
  				    . "<b>Sender/From:</b> " . ((strcmp($this->config['mail_sender'],"")<>0) ? $this->config['mail_sender'] : "") ."<br>"
  				    . "<b>Subject:</b> " . $subject . "<br>"
  				    . "<br>"
  				    . $message
  				    . "</pre>"
  				  ;
  				}
  				else {
    				@mail
    				( $this->config['mail_to']
    				, $subject
    				,	$message
    				,	((strcmp($this->config['mail_cc'],"")<>0) ? "cc: ".$this->config['mail_cc'] : "")
    				,	((strcmp($this->config['mail_sender'],"")<>0) ? "-f".$this->config['mail_sender'] : "")
    				);
    			}

  			}  // ende Info-Mail


	      if ( $this->config['mail_info_user'] == true and strcmp($this->config['mail_sender'],"")<>0) {

  				// V1.2:
  				// Ermitteln, ob an den unmittelbaren Vor-Poster eine Benachrichtigungs-
  				// eMail versandt werden kann
  				//=======================================================================
  				$emailTo      = "";
  				$emailaddress = "SELECT"
  					." gbEMail"
  				  ." FROM ".GB_TABLENAME
  					." WHERE 1=1"
  					." AND (id > ".($id-10)." AND id < ".$id.")"
  					." AND (gbEMail is not null and length(gbEMail) > 0)"
  					." ORDER BY ID DESC"
  					." LIMIT 1"
  				;

  				$rsFound = false;
  				$rs = $this->dbQuery($emailaddress);


  				// Iterieren, solange Ergbnissatz vorhanden ist
  				if($rs<>false and $rs->num_rows>0) {
  				  $rsFound = true;
  					$line    = $rs->fetch_array( MYSQLI_ASSOC );
  					$emailTo = $line['gbEMail'];

  				}

  				if ( $rsFound or  $this->config['mail_debug'] == true ) {
  				  // DEBUG-Modus aber keine DS => Daten mit "DEBUG"-Prefix simulieren
  				  if ( $this->config['mail_debug'] == true  and $rsFound == false ) {
    					$emailTo = "DEBUG_mail";
  				  }

						$subject = "Gästebuch: Antwort auf Ihren Beitrag";

            $message = $this->insertPost_getMessage
            ( GB_MAIL_MESSAGE
            , $gbID
            , $gbName
            , $gbWhen
            , $gbMail
            , $gbHomepage
            , $gbIP
            , $gbMessage
            );

    				if ($this->config['mail_debug'] == true) {
    				  $html .= ""
    				    . "<pre style=\"margin: 8px; padding: 8px; color: black; background-color:white; text-align:left; border: solid 1px black;\">"
    				    . "<b>To:</b> " . $emailTo . "<br>"
    				    . "<b>CC:</b> " . ((strcmp($this->config['mail_cc'],"")<>0) ? $this->config['mail_cc'] : "") . "<br>"
    				    . "<b>Sender/From:</b> " . ((strcmp($this->config['mail_sender'],"")<>0) ? $this->config['mail_sender'] : "") . "<br>"
    				    . "<b>Subject:</b> " . $subject . "<br>"
    				    . "<br>"
    				    // . stripslashes($message)
    				    . $message
    				    . "</pre>";
    				}
    				else {
  						@mail
  						// ( stripslashes($gbMail)
  						( $gbMail
  						,	$subject
  						,	$message
  						,	""
  						,	((strcmp($this->config['mail_sender'],"")<>0) ? "-f".$this->config['mail_sender'] : "")
  						);
  					}
  				}
				}  // end [ if ( $this->config['mail_info_user'] == true) ]
			}

			// Gästebuch anzeigen
			// ! $this->showGuestbook();
		}

		return $html;

	}  // -- end of function insertPostInDB()


  //---------------------------------------------------------------------------
  private function insertPost_getMessage
  //---------------------------------------------------------------------------
  ( $mailtext
  , $post_id       = null
  , $post_name     = null
  , $post_date     = null
  , $post_mail     = null
  , $post_homepage = null
  , $post_ip       = null
  , $post_message  = null
  )
  {

    // alle Config-Variablen durchgehen
    foreach ($this->config as $k => $v) {
      if ( is_array($v) == true ) {
        ;
      }
      else {
        $mailtext = str_replace( '##'.strToUpper($k).'##', $v, $mailtext);
        $mailtext = str_replace( '##'.strToLower($k).'##', $v, $mailtext);
      }
    }

	  $dyn_server = "";
	  $dyn_link   = $_SERVER['PHP_SELF'];

	  $httpHost = ((array_key_exists('HTTP_HOST',$_SERVER)==true) ? $_SERVER['HTTP_HOST'] : '');
	  $srvAddr  = ((array_key_exists('SERVER_ADDR',$_SERVER)==true) ? $_SERVER['SERVER_ADDR'] : '');
	  $srvPort  = ((array_key_exists('SERVER_PORT',$_SERVER)==true) ? $_SERVER['SERVER_PORT'] : '');

	  if ( strlen($srvAddr) > 0 ) {
	    $dyn_server  = "http://".$srvAddr;
	    $dyn_server .= ((strlen($srvPort)>0 and strcmp($srvPort,"80")<>0) ? ":".$srvPort : "");
	  }
	  else if ( strlen($httpHost) > 0) {
	    $dyn_server  = "http://".$httpHost;
	  }


    // mögliche Ersetzungsvariablen
    $sr = array
    ( "##POST_ID##"        => ((is_null($post_id)==false and strlen($post_id)>0)             ? $post_id                     : "")
    , "##POST_NAME##"      => ((is_null($post_name)==false and strlen($post_name)>0)         ? $post_name                   : "")
    , "##POST_DATE##"      => ((is_null($post_date)==false and strlen($post_date)>0)         ? date("d.m.Y H:i",$post_date) : "")
    , "##POST_MAIL##"      => ((is_null($post_mail)==false and strlen($post_mail)>0)         ? "mailto:".$post_mail         : "")
    , "##POST_HOMEPAGE##"  => ((is_null($post_homepage)==false and strlen($post_homepage)>0) ? $post_homepage               : "")
    , "##POST_IP##"        => ((is_null($post_ip)==false and strlen($post_ip)>0)             ? $post_ip                     : "")
    , "##POST_MESSAGE##"   => ((is_null($post_message)==false and strlen($post_message)>0)   ? $post_message                : "")

    , "##MAIL_DYN_SERVER##" => $dyn_server
    , "##MAIL_DYN_LINK##"   => $dyn_link

    );

    $mailtext = str_replace(array_keys($sr), array_values($sr), $mailtext);

    return $mailtext;
  }  // -- eof ( insertPost_getMessage ) -- //


	//---------------------------------------------------------------------------
	private function updatePostInDB()
	//---------------------------------------------------------------------------
	{
	  $html = "";
		// global $this->rt;
		// global $this->config;

		$this->rt['mode'] = "UPDATE";  // DB_UPDATE

		$gbID       = $this->gbFind('gbID',0);
		$gbName     = $this->gbFind('gbName','');
		$gbMail     = $this->gbFind('gbMail','');
		$gbHomepage = $this->gbFind('gbHomepage','');
		$gbMessage  = $this->gbFind('gbMessage','');

		$gbName     = $this->html2db($gbName);
		$gbMail     = $this->html2db($gbMail);
		$gbHomepage = $this->html2db($gbHomepage);
		$gbMessage  = $this->html2db($gbMessage);


		// auf fehlerhafte Eingabe prüfen
		$error = $this->checkData($gbName,$gbMail,$gbHomepage,$gbMessage);


		// Erstelldatum und -uhrzeit prüfen
		$dd   = $this->gbFind('gday');
		$mon  = $this->gbFind('gmon');
		$yyyy = $this->gbFind('gyear');
		$hh   = $this->gbFind('ghour');
		$mm   = $this->gbFind('gmin');

		$dd   = $this->html2db($dd);
		$mon  = $this->html2db($mon);
		$yyyy = $this->html2db($yyyy);
		$hh   = $this->html2db($hh);
		$mm   = $this->html2db($mm);


		$error = $this->checkDatum($error,$dd,$mon,$yyyy,$hh,$mm);

		// es ist mindestens ein Fehler aufgetreten
		if($error<>"") {
			$html .= $this->showErrMsg($error) . '<br>' . CRLF;
		}
		// oder die ID ist unbekannt ?
		else if($gbID==0) {
			$error = '<b>&raquo;</b> Die ID ist nicht bekannt. Der Datensatz kann nicht aktualisiert werden.';
			$html .= $this->showErrMsg($error) . '<br>' . CRLF;
		}
		else {
			// Eingaben "anpassen"
			$gbName     = strip_tags($gbName);
			$gbMail     = strip_tags($gbMail);
			$gbHomepage = strip_tags($gbHomepage);

			// "Unzulässige" Tags beim "blockquote" löschen
			$gbMessage = str_replace($this->config['quote_start'],"<blockquote>",$gbMessage);
			$gbMessage = str_replace($this->config['quote_end'],"</blockquote>",$gbMessage);

			// Message String prüfen
			$gbMessage  = strip_tags($gbMessage,$this->config['allowed_tags']);

			// Zitate (wieder) formatieren
			$gbMessage = str_replace("<blockquote>",$this->config['quote_start'],$gbMessage);
			$gbMessage = str_replace("</blockquote>",$this->config['quote_end'],$gbMessage);


			$gbWhen     = $this->createDatum($dd,$mon,$yyyy,$hh,$mm);

			// Datensatz in Tabelle einfügen
			$query = "UPDATE ".GB_TABLENAME." SET"
				."  gbWhen     = ".((!empty($gbWhen)    ) ? $this->dbMes($gbWhen)             : "NULL")
				.", gbName     = ".((!empty($gbName)    ) ? "'".$this->dbMes($gbName)."'"     : "NULL")
				.", gbEMail    = ".((!empty($gbEMail)   ) ? "'".$this->dbMes($gbEMail)."'"    : "NULL")
				.", gbHomepage = ".((!empty($gbHomepage)) ? "'".$this->dbMes($gbHomepage)."'" : "NULL")
				.", gbMessage  = ".((!empty($gbMessage) ) ? "'".$this->dbMes($gbMessage)."'"  : "NULL")
				." WHERE 1=1"
				."  AND gbID = ".$this->dbMes($gbID)
			;

			$affected = $this->dbUpdate($query);

			// keine Zeile verändert
			if($affected==0) {
				$message = ''
				  .'Der Datensatz wurde nicht verändert. M&ouml;gliche Ursachen'
					.' k&ouml;nnen sein:<br>'
					.'<b>&raquo;</b> der Datensatz wurde nicht ver&auml;ndert<br>'
					.'<b>&raquo;</b> die Verbindung zur Datenbank konnte nicht hergestellt'
					.' werden<br>';
				$html .= $this->showErrMsg($message) . '<br>' . CRLF;
			}
		}

		// $html .= $this->adminGuestbook();

		return $html;

	}  // -- end of function insertPostInDB()


	// Eintrag aus der DB löschen
	function deletePostInDB() {
	  $html = "";

		$this->rt['mode'] = "DELETE";  // DB_DELETE

		$gbID = $this->gbFind('gbID',0);

		// Ist die ID unbekannt ?
		if($gbID==0) {
			$error = "<b>&raquo;</b> Die ID ist nicht bekannt. Der Eintrag kann nicht gelöscht werden.";
			$html .= $this->showErrMsg($error) . "<br>\n";
		}
		else {
			// Datensatz aus der Tabelle entfernen
			$query = "DELETE FROM ".GB_TABLENAME." WHERE gbID=".$this->dbMes($gbID);
			$this->dbQuery($query);
		}

		return $html;

	}  // -- eof ( deletePostInDB ) -- //




	// POST PREVIEW
	function previewPost( $doCheck )
	{
	  $html = "";

		$this->rt['mode'] = "PREVIEW";

		$gbName     = $this->gbFind('gbName');
		$gbMail     = $this->gbFind('gbMail');
		$gbHomepage = $this->gbFind('gbHomepage');
		$gbMessage  = $this->gbFind('gbMessage');


	  if ( strlen($gbMail)>0 and strpos($gbMail, "@@") > 0) {
	    $arr = preg_split("/@@/", $gbMail);

	    if (    array_key_exists( "0", $arr)
	        and strcmp($arr[0], $this->config['adm_name']) == 0
	        and array_key_exists( "1", $arr)
	        and strcmp($arr[1], $this->config['adm_pw']) == 0
	       )
	    {
	      $parms = array( "gbaction" => "ADMIN"
	                    , "admMD5"   => $this->rt['adm-md5']
	                    );
	      $href = $this->getHREF($parms);

	      // versuchen auf die Seiter zurückzuleiten
	      if ( headers_sent() == false ) {
	        header("Location: ".$href);
	        exit();
	      }
	      else {
	        echo "<a href=\"".$href."\"><code>Login: ".$href."</code></a><br>";
	        exit();
	      }
	    }
	  }


		// Message wegen Zitaten extra aufbereiten
		$gbMessage = str_replace("<blockquote>",$this->config['quote_start'],$gbMessage);
		$gbMessage = str_replace("</blockquote>",$this->config['quote_end'],$gbMessage);

		// auf fehlerhafte Eingabe prüfen
		$error = "";
		if ( $doCheck ) {
		  $error = $this->checkData($gbName,$gbMail,$gbHomepage,$gbMessage);
		}

		// es ist mindestens ein Fehler aufgetreten
		if($error<>"") {
			$html .= $this->showErrMsg($error) . '<br>' . CRLF;
		}


		// Nachricht als "Vorschau" anzeigen
		$html .= $this->open_View_Table();
		$html .= $this->show_View_Main("",$gbName,time(),$gbMail,$gbHomepage,$gbMessage);
		$html .= $this->close_View_Table();

		// Tabelle "View" von "Eingabe" trennen
		$html .= '<br>' . CRLF;

		// Form zur Eingabe ebenfalls anzeigen
		$html .= $this->show_EditPostForm();

		return $html;

	}  // -- eof ( previewPost ) -- //



	// ============================================================================

	// admin ----------------------------------------------------------------------

	private function adminGuestbook() {
		$html = "";

		// Modus in "ADMIN" --> Zeige das Gästebuch im Admin-Modus an
		$this->rt['mode'] = "ADMIN";

		// Parameter vorhanden
		$gbID    = $this->gbFind('gbID',0);
		$page    = $this->gbFind('p',1);
		$perpage = $this->gbFind('pp',$this->config['perpage']);

		// Anzahl der Post's in der DB
		$postcount = $this->countPostsInDB();

		// Query Statement zusammensetzen
		$query = "SELECT gbID,gbWhen,gbName,gbEMail,gbHomepage,gbMessage FROM ".GB_TABLENAME." ORDER BY gbID DESC LIMIT ".(($page-1)*$perpage).",".$perpage;

		// Query ausführen
		$rs = $this->dbQuery($query);

		// Iterieren, solange Ergbnissatz vorhanden ist
		if($rs<>false and $rs->num_rows>0) {
			$parms = NULL;
			if ( $this->rt['is_admin'] == true) {
			  $parms = array
			  ( "gbaction" => "admin"
			  , "admMD5"   => $this->rt['adm-md5']
			  );
			}

			$html .= $this->navigationBar($postcount,$page,$perpage,$parms,1);
			$html .= $this->open_Edit_Table();
		  while($line = $rs->fetch_array(MYSQLI_ASSOC) ) {
		    $html .= '<form name="GBEDIT'.$line['gbID'].'" action="'.$this->config['phpself'].'" method="GET">' . CRLF;
    		if (    array_key_exists( 'external_params' , $this->config ) == true
    		    and is_array($this->config['external_params'])
    		   )
    		{
    		  foreach ( $this->config['external_params'] as $k => $v) {
    		    $html .= '<input type="hidden" name="'.$k.'" value="'.((is_null($v)==false) ? $v : '').'">' . CRLF;
    		  }
    		}
		    $html .= '<input type="hidden" name="gbID" value="'.$line['gbID'].'">' . CRLF;
		    if($gbID<>$line['gbID']) {
		    	$html .= $this->show_Edit_Main("GBEDIT".$line['gbID'],
		    		$line['gbID'],
			    	$line['gbWhen'],
			    	$line['gbName'],
			    	$line['gbEMail'],
			    	$line['gbHomepage'],
			    	$line['gbMessage'],
			    	NULL);
			  }
			  else {
			  	$datum = array(
			  		"dd"   => $this->gbFind('gday'),
			  		"mon"  => $this->gbFind('gmon'),
			  		"yyyy" => $this->gbFind('gyear'),
			  		"hh"   => $this->gbFind('ghour'),
			  		"mm"   => $this->gbFind('gmin')
			  	);
		    	$html .= $this->show_Edit_Main("GBEDIT".$line['gbID'],
		    		$line['gbID'],
			    	0,
			    	$this->gbFind('gbName'),
			    	$this->gbFind('gbMail'),
			    	$this->gbFind('gbHomepage'),
			    	$this->gbFind('gbMessage'),
			    	$datum);
			  }  // -- end else

		    $html .= ''
		      .'<input type="hidden" name="p"      value="'.$this->gbFind('p',1).'">' . CRLF
		      .'<input type="hidden" name="pp"     value="'.$this->gbFind('pp',$this->config['perpage']).'">' . CRLF
		      .'<input type="hidden" name="admMD5" value="'.$this->rt['adm-md5'].'">' . CRLF
		      .'</form>' . CRLF
		    ;
		  }
		  $html .= $this->close_Edit_Table();
			$html .= $this->navigationBar($postcount,$page,$perpage,$parms);
		}

		// Zurück zum Gästebuch
		$html .= '<p align="center"><a href="'.$this->getHREF(null).'">Zur&uuml;ck zum G&auml;stebuch</a></p>' . CRLF;

		return $html;


	}  // -- eof ( adminGuestbook ) -- //



	// ============================================================================

	// show (Gästebuch anzeigen) --------------------------------------------------

	private function showGuestbook() {
	  $html = "";

		// Link, um einen Eintrag dem Gästebuch hinzuzufügen
		if ( $this->config['edit'] == true and $this->config['addpost_top_on']==true ) {
  		$html .= ''
  		  .'<p align="center"><a href="'.$this->getHREF(array("gbaction" => "ADDPOST")).'">'
  			.($this->config['addpost_top_image']<>""
  			    ? '<img src="'.$this->config['addpost_top_image'].'" alt="'.$this->config['addpost_top_image'].'" border="0"><br>'
  			    : ''
  			 )
  			.$this->config['addpost_top_linktext']
  			.'</a></p>' . CRLF
  		;
	  }


		// Modus in "SHOW" --> Zeige das Gästebuch schalten
		$this->rt['mode'] = "SHOW";

		// Parameter vorhanden
		$page    = isset($_GET['p'])==true  ? $_GET['p']    : 1;
		$perpage = isset($_GET['pp'])==true ? $_GET['pp'] : $this->config['perpage'];

    // IP-Bereinigung ausführen
    $this->cleanupIP();

		// Anzahl der Post's in der DB
		$postcount = $this->countPostsInDB();


		// Query Statement zusammensetzen
		$query = "SELECT gbID,gbWhen,gbName,gbEMail,gbHomepage,gbMessage  FROM ".GB_TABLENAME." ORDER BY gbID DESC LIMIT ".(($page-1)*$perpage).",".$perpage;

		// Query ausführen
		$rs = $this->dbQuery($query);


		// Iterieren, solange Ergbnissatz vorhanden ist
		if($rs<>false and $rs->num_rows>0) {

			$parms = NULL;
			if ( $this->rt['is_admin'] == true) {
			  $parms = array
			  ( "gbaction" => "admin"
			  , "admMD5"   => $this->rt['adm-md5']
			  );
			}

			$i=0;
			$html .= $this->navigationBar($postcount,$page,$perpage,$parms,1);
			$html .= $this->open_View_Table();
		  while($line = $rs->fetch_array(MYSQLI_ASSOC)) {
		    $html .= $this->show_View_Main($line['gbID'],
		    	$line['gbName'],
		    	$line['gbWhen'],
		    	$line['gbEMail'],
		    	$line['gbHomepage'],
		    	$line['gbMessage']);
		  }
		  $html .= $this->close_View_Table();
			$html .= $this->navigationBar($postcount,$page,$perpage,$parms);
		}
		else {
			$html .= $this->showErrMsg("<b>&raquo;</b> Derzeit keine Einträge vorhanden.",null);
		}


		// Link, um einen Eintrag dem Gästebuch hinzuzufügen
		if ( $this->config['edit'] == true and  $this->config['addpost_bottom_on']==true  ) {
  		$html .= ''
  		  .'<p align="center"><a href="'.$this->getHREF(array("gbaction"=>"ADDPOST")).'">'
  			.($this->config['addpost_bottom_image']<>""
  			    ? '<img src="'.$this->config['addpost_bottom_image'].'" alt="'.$this->config['addpost_bottom_image'].'" border="0"><br>'
  			    : ''
  			 )
  			.$this->config['addpost_bottom_linktext']
  			.'</a></p>' . CRLF
  		;
  	}

    return $html;

	}  // -- eof ( showGuestbook ) -- //



	// ============================================================================

	// view ---------------------------------------------------------------------

	private function open_View_Table() {
		return ''
		  .'<table border="0" align="center" cellpadding="3" cellspacing="1">' . CRLF
			.'<tr class="head">' . CRLF
			.'  <td align="left"><b>Name</b></td>' . CRLF
			.'  <td align="left"><b>Nachricht</b></td>' . CRLF
			.'</tr>' . CRLF
	  ;


	}


	private function show_View_Main($gbID=0,$name="",$when=0,$mail="",$homepage="",$message="") {
		$html = "";

		// Eingaben "anpassen"
		$name     = strip_tags($name);
		$mail     = strip_tags($mail);
		$homepage = strip_tags($homepage);
		$style_row  = "";
		$style_text = "";


		// "Unzulässige" Tags beim "blockquote" löschen
		$message = str_replace($this->config['quote_start'],"<blockquote>",$message);
		$message = str_replace($this->config['quote_end'],"</blockquote>",$message);

		// Message String prüfen
		$message  = strip_tags($message,$this->config['allowed_tags']);

		// Zitate (wieder) formatieren
		$message = str_replace("<blockquote>",$this->config['quote_start'],$message);
		$message = str_replace("</blockquote>",$this->config['quote_end'],$message);

		$message  = nl2br($message);

		// Smileys einsetzen
		$sm_arr = array(
		  /* smile    */  ":)"          => "<img src=\"".$this->config['images']."/smile.gif\" alt=\"smile.gif\" border=\"0\">"
		,	/* frown    */  ":("          => "<img src=\"".$this->config['images']."/frown.gif\" alt=\"frown.gif\" border=\"0\">"
		,	/* biggrin  */  ":D"          => "<img src=\"".$this->config['images']."/biggrin.gif\" alt=\"biggrin.gif\" border=\"0\">"
		,	/* wink     */  ";)"          => "<img src=\"".$this->config['images']."/wink.gif\" alt=\"wink.gif\" border=\"0\">"
		,	/* tongue   */  ":p"          => "<img src=\"".$this->config['images']."/tongue.gif\" alt=\"tongue.gif\" border=\"0\">"
		,	/* cool     */  ":cool:"      => "<img src=\"".$this->config['images']."/cool.gif\" alt=\"cool.gif\" border=\"0\">"
		,	/* rolleyes */  ":rolleyes:"  => "<img src=\"".$this->config['images']."/rolleyes.gif\" alt=\"rolleyes.gif\" border=\"0\">"
		,	/* mad      */  ":mad:"       => "<img src=\"".$this->config['images']."/mad.gif\" alt=\"mad.gif\" border=\"0\">"
		,	/* eek2     */  ":eek2"       => "<img src=\"".$this->config['images']."/eek2.gif\" alt=\"eek2.gif\" border=\"0\">"
		,	/* confused */  ":confused:"  => "<img src=\"".$this->config['images']."/confused.gif\" alt=\"confused.gif\" border=\"0\">"
		,	/* blushie  */  ":ups"        => "<img src=\"".$this->config['images']."/blushie.gif\" alt=\"blushie.gif\" border=\"0\">"
		,	/* bye      */  ":wink"       => "<img src=\"".$this->config['images']."/bye.gif\" alt=\"bye.gif\" border=\"0\">"
		,	/* clown    */  ":clown"      => "<img src=\"".$this->config['images']."/clown.gif\" alt=\"clown.gif\" border=\"0\">"
		,	/* conf     */  ":frage"      => "<img src=\"".$this->config['images']."/conf.gif\" alt=\"conf.gif\" border=\"0\">"
		,	/* love     */  ":love"       => "<img src=\"".$this->config['images']."/love.gif\" alt=\"love.gif\" border=\"0\">"
		,	/* sure.gif */  ":mix"        => "<img src=\"".$this->config['images']."/sure.gif\" alt=\"sure.gif\" border=\"0\">"
		,	/* angel2-1 */  ":angel2"     => "<img src=\"".$this->config['images']."/angel2-1.gif\" alt=\"angel2-1.gif\" border=\"0\">"
		,	/* anger    */  ":hass"       => "<img src=\"".$this->config['images']."/anger.gif\" alt=\"anger.gif\" border=\"0\">"
		,	/* zwinker  */  ":zwinker"    => "<img src=\"".$this->config['images']."/zwinker.gif\" alt=\"zwinker.gif\" border=\"0\">"
		,	/* devil    */  ":devil"      => "<img src=\"".$this->config['images']."/devil.gif\" alt=\"devil.gif\" border=\"0\">"
		,	/* dizzy    */  ":dizzy"      => "<img src=\"".$this->config['images']."/dizzy.gif\" alt=\"dizzy.gif\" border=\"0\">"
		,	/* eek      */  ":eek:"       => "<img src=\"".$this->config['images']."/eek.gif\" alt=\"eek.gif\" border=\"0\">"
		,	/* fuckyou2 */  ":fuckyou2"   => "<img src=\"".$this->config['images']."/fuckyou2.gif\" alt=\"fuckyou2.gif\" border=\"0\">"
		,	/* chinese  */  ":chinese"    => "<img src=\"".$this->config['images']."/chinese.gif\" alt=\"chinese.gif\" border=\"0\">"
		,	/* alien    */  ":alien"      => "<img src=\"".$this->config['images']."/alien.gif\" alt=\"aliengif\" border=\"0\">"
		);


		$message = str_replace(array_keys($sm_arr), array_values($sm_arr), $message);

    $clazz = "";
		if($this->rt['bg_counter']==0) {
		  $this->rt['bg_counter']=1;
		  $clazz = "base";
		}
		else {
		  $this->rt['bg_counter']=0;
		  $clazz = "base-alt";
		}

		$datum   = date("d.m.Y",$when);
		$uhrzeit = date("H:i",$when);

		$html .= ''
		  .'<tr class="'.$clazz.'">' . CRLF
			.'  <td align="left" valign="top" width="180px"><b>'.$name.'</b></td>' . CRLF
			.'  <td align="left">'
			.((strlen($when) > 0 and $when <> 0 )
	         ? '<small>erstellt am <b>'.$datum.'</b> um <b>'.$uhrzeit.'</b></small>'
	         : '<small>erstellt am: <b>unbekannt</b></small>'
	     )
			.((strlen($mail) > 0)
			      // ? '&nbsp;<a href="mailto:'.$mail.'"><img src="'.$this->config['images'].'/email.gif" alt="mail" border="0"></a>'
			      ? '&nbsp;<a href="mailto:YES"><img src="'.$this->config['images'].'/email.gif" alt="mail" border="0"></a>'
			      : ''
			 )
			.((strlen($homepage) > 0)
			      ? '&nbsp;<a href="'.$homepage.'"><img src="'.$this->config['images'].'/home.gif" alt="home" border="0"></a>'
			      : ''
			 )
			.'<hr size=1>'
			.$message
			.'</td>' . CRLF
			.'</tr>' . CRLF
		;

		return $html;

	}  // -- eof ( show_View_Main ) -- //


	private function close_View_Table() {
		return "</table>\n";
	}



	// edit ---------------------------------------------------------------------


	private function open_Edit_Table() {
		return ''
		  .'<table border="0" align="center" cellspacing="1" cellpadding="0">' . CRLF
			.'<tr class="head">' . CRLF
			.'  <td align="center" colspan="'.($this->rt['is_admin']==false ? 2 : 3).'"><b>Ihr Eintrag</b></td>' . CRLF
			.'</tr>' . CRLF
			.'<tr class="subhead">' . CRLF
			.'  <td align="left" colspan="'.($this->rt['is_admin']==false ? 2 : 3).'">' . CRLF
			.'<small>"Name" und "Nachricht" sind Pflichtfelder!</small>'
			.'</td>' . CRLF
			.'</tr>' . CRLF
	  ;
	}



	/**
	 * @param formname der Name der Form in der die Daten angezeigt werden. Der
	 *        Formname wird wegen der JavaScript Funktionalität benötigt
	 *
	 * @param $datum Array, der die Datum/Uhrzeit Angaben enthält. Folgende
	 *        Elemente muss der Array enthalten:
	 *        dd => Tag
	 *        mon => Monat
	 *        yyyy => Jahr
	 *        hh   => Stunden
	 *        mm   => Minuten
	 *        ss   => Sekunden (optional)
	 * @return *kein Rückgabewert*
	*/
	function show_Edit_Main($formname,$gbID="",$gbWhen=0,$gbName="",$gbMail="",$gbHomepage="",$gbMessage="",$datum=NULL) {
		$html = "";

    /*
		$gbName     = stripslashes($gbName);
		$gbMail     = stripslashes($gbMail);
		$gbHomepage = stripslashes($gbHomepage);
		$gbMessage  = stripslashes($gbMessage);
		*/

		$style_row  = "";
		$style_text = "";

		if($datum<>NULL) {
			$dd   = $datum['dd'];
			$mon  = $datum['mon'];
			$yyyy = $datum['yyyy'];
			$hh   = $datum['hh'];
			$mm   = $datum['mm'];
		}
		else {
			if($gbWhen==0 or $gbWhen==NULL) {
				$dd   = -1;
				$mon  = -1;
				$yyyy = -1;
				$hh   = -1;
				$mm   = -1;
				$ss   = -1;
			}
			else {
				$dd   = date("d",$gbWhen);
				$mon  = date("m",$gbWhen);
				$yyyy = date("Y",$gbWhen);
				$hh   = date("H",$gbWhen);
				$mm   = date("i",$gbWhen);
				$ss   = date("s",$gbWhen);
			}
		}

    $clazz = "";
		if($this->rt['bg_counter']==0) {
		  $this->rt['bg_counter']=1;
		  $clazz = "base";
		}
		else {
		  $this->rt['bg_counter']=0;
		  $clazz = "base-alt";
		}


		$html .= ''
			.'<tr class="'.$clazz.'">' . CRLF
			.'  <td width="180px"><b>Name</b></td>' . CRLF
			.'  <td width="100%"><input type="text" name="gbName" value="'.$gbName.'" size="60" maxlength="40">' . CRLF
			.(($this->rt['is_admin']==true)
			    ? '  <td rowspan="5" align="center" valign="top">' . CRLF
  			   .'    <b># '.$gbID.'</b><br>'
  				 .'    <input type="submit" name="gbaction" value="Update" style="width:80px; height:20px; color:#2020CC; font-size:12px; font-weight:bold;">' . CRLF
  				 .'    <input type="submit" name="gbaction" value="Delete" style="width:80px; height:20px; color:#CC2020; font-size:12px; font-weight:bold;">' . CRLF
  				 .'  </td>' . CRLF
  				: ''
  		)
			.'</tr>' . CRLF
			.'<tr class="'.$clazz.'">' . CRLF
			.'  <td>E-Mail</td>' . CRLF
			.'  <td><input type="text" name="gbMail" value="'.$gbMail.'" size="60" maxlength="80">' . CRLF
			.'</tr>' . CRLF
			.'<tr class="'.$clazz.'">' . CRLF
			.'  <td>Homepage</td>' . CRLF
			.'  <td><input type="text" name="gbHomepage" value="'.$gbHomepage.'" size="60" maxlength="80">' . CRLF
			.'</tr>' . CRLF
			.(($this->rt['is_admin']==true)
			    ? '<tr class="'.$clazz.'">' . CRLF
  				.'  <td align="left" valign="top">Eintrag</td>' . CRLF
  				.'  <td nowrap="nowrap"><small>erstellt am&nbsp;' . CRLF
  				.'  <select name="gday" style="width:44px; height:16px; font-size:12px;">' . CRLF
  				.'    <option value="-1"'.($dd==-1 ? ' selected' : '').'></option>' . CRLF
  				.'    <option value="1"' .($dd==1  ? ' selected' : '').'>01</option>' . CRLF
  				.'    <option value="2"' .($dd==2  ? ' selected' : '').'>02</option>' . CRLF
  				.'    <option value="3"' .($dd==3  ? ' selected' : '').'>03</option>' . CRLF
  				.'    <option value="4"' .($dd==4  ? ' selected' : '').'>04</option>' . CRLF
  				.'    <option value="5"' .($dd==5  ? ' selected' : '').'>05</option>' . CRLF
  				.'    <option value="6"' .($dd==6  ? ' selected' : '').'>06</option>' . CRLF
  				.'    <option value="7"' .($dd==7  ? ' selected' : '').'>07</option>' . CRLF
  				.'    <option value="8"' .($dd==8  ? ' selected' : '').'>08</option>' . CRLF
  				.'    <option value="9"' .($dd==9  ? ' selected' : '').'>09</option>' . CRLF
  				.'    <option value="10"'.($dd==10 ? ' selected' : '').'>10</option>' . CRLF
  				.'    <option value="11"'.($dd==11 ? ' selected' : '').'>11</option>' . CRLF
  				.'    <option value="12"'.($dd==12 ? ' selected' : '').'>12</option>' . CRLF
  				.'    <option value="13"'.($dd==13 ? ' selected' : '').'>13</option>' . CRLF
  				.'    <option value="14"'.($dd==14 ? ' selected' : '').'>14</option>' . CRLF
  				.'    <option value="15"'.($dd==15 ? ' selected' : '').'>15</option>' . CRLF
  				.'    <option value="16"'.($dd==16 ? ' selected' : '').'>16</option>' . CRLF
  				.'    <option value="17"'.($dd==17 ? ' selected' : '').'>17</option>' . CRLF
  				.'    <option value="18"'.($dd==18 ? ' selected' : '').'>18</option>' . CRLF
  				.'    <option value="19"'.($dd==19 ? ' selected' : '').'>19</option>' . CRLF
  				.'    <option value="20"'.($dd==20 ? ' selected' : '').'>20</option>' . CRLF
  				.'    <option value="21"'.($dd==21 ? ' selected' : '').'>21</option>' . CRLF
  				.'    <option value="22"'.($dd==22 ? ' selected' : '').'>22</option>' . CRLF
  				.'    <option value="23"'.($dd==23 ? ' selected' : '').'>23</option>' . CRLF
  				.'    <option value="24"'.($dd==24 ? ' selected' : '').'>24</option>' . CRLF
  				.'    <option value="25"'.($dd==25 ? ' selected' : '').'>25</option>' . CRLF
  				.'    <option value="26"'.($dd==26 ? ' selected' : '').'>26</option>' . CRLF
  				.'    <option value="27"'.($dd==27 ? ' selected' : '').'>27</option>' . CRLF
  				.'    <option value="28"'.($dd==28 ? ' selected' : '').'>28</option>' . CRLF
  				.'    <option value="29"'.($dd==29 ? ' selected' : '').'>29</option>' . CRLF
  				.'    <option value="30"'.($dd==30 ? ' selected' : '').'>30</option>' . CRLF
  				.'    <option value="31"'.($dd==31 ? ' selected' : '').'>31</option>' . CRLF
  				.'  </select>&nbsp' . CRLF

  				.'  <select name="gmon"  style="width:44px; height:16px; font-size:12px;">' . CRLF
  				.'    <option value="-1"'.($mon==-1 ? ' selected' : '').'></option>' . CRLF
  				.'    <option value="1"' .($mon==1  ? ' selected' : '').'>01</option>' . CRLF
  				.'    <option value="2"' .($mon==2  ? ' selected' : '').'>02</option>' . CRLF
  				.'    <option value="3"' .($mon==3  ? ' selected' : '').'>03</option>' . CRLF
  				.'    <option value="4"' .($mon==4  ? ' selected' : '').'>04</option>' . CRLF
  				.'    <option value="5"' .($mon==5  ? ' selected' : '').'>05</option>' . CRLF
  				.'    <option value="6"' .($mon==6  ? ' selected' : '').'>06</option>' . CRLF
  				.'    <option value="7"' .($mon==7  ? ' selected' : '').'>07</option>' . CRLF
  				.'    <option value="8"' .($mon==8  ? ' selected' : '').'>08</option>' . CRLF
  				.'    <option value="9"' .($mon==9  ? ' selected' : '').'>09</option>' . CRLF
  				.'    <option value="10"'.($mon==10 ? ' selected' : '').'>10</option>' . CRLF
  				.'    <option value="11"'.($mon==11 ? ' selected' : '').'>11</option>' . CRLF
  				.'    <option value="12"'.($mon==12 ? ' selected' : '').'>12</option>' . CRLF
  				.'  </select>&nbsp' . CRLF
  				.'  <input type="text" name="gyear" value="'.($yyyy<>-1 ? $yyyy : '').'" size="4" maxlength="4" style="width:40px; height:18px; font-size:12px;">' . CRLF
  				.'  &nbsp;um&nbsp;' . CRLF
  				.'  <input type="text" name="ghour" value="'.($hh<>-1 ? $hh : '').'" style="width:24px; height:18px; font-size:12px;">:' . CRLF
  				.'  <input type="text" name="gmin"  value="'.($mm<>-1 ? $mm : '').'" style="width:24px; height:18px; font-size:12px;">' . CRLF
  				.'  </small></td>' . CRLF
  				.'</tr>' . CRLF
  			: ''
  		)
  		.'<tr class="'.$clazz.'">' . CRLF
			.'  <td align="left" valign="top">' . CRLF
			.'    <b>Nachricht</b>' . CRLF
		;

		$js_message = "document.".$formname.".gbMessage";

		// Smiley's anzeigen
		$html .= ''
		  .'<br>'
			.'<table border="0" cellspacing="1" cellpadding="1" align="center" bgcolor="#656565">' . CRLF
			.'<tr class="'.$clazz.'">'
			.'<td>'
			.'<table border="0" cellspacing="1" cellpadding="2" width="100%" align="center">' . CRLF
			.'<tr bgcolor="#656565">' . CRLF
			.'  <td colspan="5"><font color="white"><b><small>Smiley</small></b></font></td>' . CRLF
			.'</tr>' . CRLF

			."<tr>\n"
			."  <td><a href=\"javascript:addSmiley(".$js_message.", ' :)')\"><img src=\"".$this->config['images']."/smile.gif\" alt=\"smile\" border=\"0\"/></a></td>\n"
			."  <td><a href=\"javascript:addSmiley(".$js_message.",' :(')\"><img src=\"".$this->config['images']."/frown.gif\" alt=\"frown\" border=\"0\"/></a></td>\n"
			."  <td><a href=\"javascript:addSmiley(".$js_message.",' :D')\"><img src=\"".$this->config['images']."/biggrin.gif\" alt=\"biggrin\" border=\"0\"/></a></td>\n"
			."  <td><a href=\"javascript:addSmiley(".$js_message.",' ;)')\"><img src=\"".$this->config['images']."/wink.gif\" alt=\"wink\" border=\"0\"/></a></td>\n"
			."  <td><a href=\"javascript:addSmiley(".$js_message.",' :p')\"><img src=\"".$this->config['images']."/tongue.gif\" alt=\"tongue\" border=\"0\"/></a></td>\n"
			."</tr>\n"
			."<tr>\n"
			."  <td><a href=\"javascript:addSmiley(".$js_message.",' :cool:')\"><img src=\"".$this->config['images']."/cool.gif\" alt=\"cool\" border=\"0\"/></a></td>\n"
			."  <td><a href=\"javascript:addSmiley(".$js_message.",' :rolleyes:')\"><img src=\"".$this->config['images']."/rolleyes.gif\" alt=\"rolleyes\" border=\"0\"/></a></td>\n"
			."  <td><a href=\"javascript:addSmiley(".$js_message.",' :mad:')\"><img src=\"".$this->config['images']."/mad.gif\" alt=\"mad\" border=\"0\"/></a></td>\n"
			."  <td><a href=\"javascript:addSmiley(".$js_message.",' :eek2')\"><img src=\"".$this->config['images']."/eek2.gif\" alt=\"eek2\" border=\"0\"/></a></td>\n"
			."  <td><a href=\"javascript:addSmiley(".$js_message.",' :confused:')\"><img src=\"".$this->config['images']."/confused.gif\" alt=\"confused\" border=\"0\"/></a></td>\n"
			."</tr>\n"

			."<tr>\n"
			."  <td><a href=\"javascript:addSmiley(".$js_message.",' :ups')\"><img src=\"".$this->config['images']."/blushie.gif\" alt=\"blushie\" border=\"0\"/></a></td>\n"
			."  <td><a href=\"javascript:addSmiley(".$js_message.",' :wink')\"><img src=\"".$this->config['images']."/bye.gif\" alt=\"bye\" border=\"0\"/></a></td>\n"
			."  <td><a href=\"javascript:addSmiley(".$js_message.",' :clown')\"><img src=\"".$this->config['images']."/clown.gif\" alt=\"clown\" border=\"0\"/></a></td>\n"
			."  <td><a href=\"javascript:addSmiley(".$js_message.",' :frage')\"><img src=\"".$this->config['images']."/conf.gif\" alt=\"conf\" border=\"0\"/></a></td>\n"
			."  <td><a href=\"javascript:addSmiley(".$js_message.",' :love')\"><img src=\"".$this->config['images']."/love.gif\" alt=\"love\" border=\"0\"/></a></td>\n"
			."</tr>\n"

			."<tr>\n"
			."  <td><a href=\"javascript:addSmiley(".$js_message.",' :mix')\"><img src=\"".$this->config['images']."/sure.gif\" alt=\"sure\" border=\"0\"/></a></td>\n"
			."  <td><a href=\"javascript:addSmiley(".$js_message.",' :angel2')\"><img src=\"".$this->config['images']."/angel2-1.gif\" alt=\"angel2-1\" border=\"0\"/></a></td>\n"
			."  <td><a href=\"javascript:addSmiley(".$js_message.",' :hass')\"><img src=\"".$this->config['images']."/anger.gif\" alt=\"anger\" border=\"0\"/></a></td>\n"
			."  <td><a href=\"javascript:addSmiley(".$js_message.",' :zwinker')\"><img src=\"".$this->config['images']."/zwinker.gif\" alt=\"zwinker\" border=\"0\"/></a></td>\n"
			."  <td><a href=\"javascript:addSmiley(".$js_message.",' :devil')\"><img src=\"".$this->config['images']."/devil.gif\" alt=\"devil\" border=\"0\"/></a></td>\n"
			."</tr>\n"

			."<tr>\n"
			."  <td><a href=\"javascript:addSmiley(".$js_message.",' :dizzy')\"><img src=\"".$this->config['images']."/dizzy.gif\" alt=\"dizzy\" border=\"0\"/></a></td>\n"
			."  <td><a href=\"javascript:addSmiley(".$js_message.",' :eek:')\"><img src=\"".$this->config['images']."/eek.gif\" alt=\"eek\" border=\"0\"/></a></td>\n"
			."  <td><a href=\"javascript:addSmiley(".$js_message.",' :fuckyou2')\"><img src=\"".$this->config['images']."/fuckyou2.gif\" alt=\"fuckyou2\" border=\"0\"/></a></td>\n"
			."  <td><a href=\"javascript:addSmiley(".$js_message.",' :chinese')\"><img src=\"".$this->config['images']."/chinese.gif\" alt=\"chinese\" border=\"0\"/></a></td>\n"
			."  <td><a href=\"javascript:addSmiley(".$js_message.",' :alien')\"><img src=\"".$this->config['images']."/alien.gif\" alt=\"alien\" border=\"0\"/></a></td>\n"
			."</tr>\n"


			.'</table>' . CRLF
			.'</td></tr>' . CRLF
			.'</table><br>' . CRLF

			.'  </td>' . CRLF
			.'  <td>'
			.'<small><b>Erlaubte Tags:</b> '.str_replace( array( '<','>'), array('&lt;','&gt;'), $this->config['allowed_tags']).'</small>'
			.'<br><textarea name="gbMessage" rows="10" cols="60">'.$gbMessage.'</textarea></td>' . CRLF
			.'</tr>' . CRLF
		;

		return $html;

	}  // end of function show_Edit_Main()


	private function close_Edit_Table() {
		return '</table>' . CRLF;
	}



	private function showButtons() {
		return ''
		  .'<table style="background-color:transparent;" border="0" align="center">' . CRLF
			.'<tr>' . CRLF
			.'  <td width="25%"></td>' . CRLF
			.'  <td align="center" style="text-align:center;"  width="50%" nowrap="nowrap">' . CRLF
			.'    <input type="submit" name="gbaction" value="Vorschau">&nbsp;' . CRLF
			.'    <input type="submit" name="gbaction" value="Eintragen">' . CRLF
			//.'  <button type="button" onClick="setGBAction(\'VORSCHAU\');">Vorschau</button>' . CRLF
			//.'  <button type="button" onClick="setGBAction(\'EINTRAGEN\');">Eintragen</button>' . CRLF
			.'  </td>' . CRLF
			.'  <td align="right" style="text-align:right;"  width="25%" nowrap="nowrap">' . CRLF
			.'    <input type="submit" name="gbaction" value="Zur&uuml;ck zum G&auml;stebuch">' . CRLF
			//.'    <button type="button" onClick="setGBAction(\'BACK\');">Zurück zum Gästebuch</button>' . CRLF
			.'  </td>' . CRLF
			.'</tr>' . CRLF
			.'</table>' . CRLF
		;

	}  // end of function showButtons()


	private function openForm() {
		// global $this->config;

		$html = ''
		  .'<!-- *** OPEN GUESTBOOK FORM *** -->' . CRLF
		  .'<form name="VDGUESTBOOK" action="'.$this->config['phpself'].'" method="POST">' . CRLF
		;

		if (    array_key_exists( 'external_params' , $this->config ) == true
		    and is_array($this->config['external_params'])
		   )
		{
		  foreach ( $this->config['external_params'] as $k => $v) {
		    $html .= '<input type="hidden" name="'.$k.'" value="'.((is_null($v)==false) ? $v : '').'">' . CRLF;
		  }
		}

		return $html;
	}


	private function closeForm() {
		return '</form>' . CRLF
		  .'<!-- *** CLOSE GUESTBOOK FORM *** -->' . CRLF
		;
	}


	//=============================================================================

	// db -------------------------------------------------------------------------


	private function dbQuery($query) {
    $result = $this->rt['connection']->query( $query );
    return $result;
	}


	/**
	 * @param $query das INSERT Statement
	 *
	 * @return 0, wenn der Datensatz nicht eingefügt wurde, ansonsten die ID des
	 *         des Datensatzes
	*/
	private function dbInsert($query) {
		$id = 0;
		$result = $this->dbQuery($query);
		if($result<>FALSE) {
			$id = $this->rt['connection']->insert_id;
		}
		return $id;
	}


	/**
	 * @param $query das UPDATE Statement
	 *
	 * @return 0, wenn kein Datensatz verändert wurde, ansonsten die Anzahl der
	 *         geänderten Datensätze
	*/
	private function dbUpdate($query) {
		$affected = 0;
		$result = $this->dbQuery($query);
		if($result<>FALSE) {
			$affected = $this->rt['connection']->affected_rows;
		}
		return $affected;
	}

	private function dbMes($str) {
		return ((is_null($str)==true) ? NULL : mysqli_real_escape_string($this->rt['connection'], $str));
	}

	private function countPostsInDB() {
		// global $this->config;
		$count = 0;

		// Query Statement
		$query = "SELECT count(gbID) as cntgbid FROM ".GB_TABLENAME;

		// Query ausführen....
		$rs = $this->dbQuery($query);

		//... und auswerten
		if($rs<>false and $rs->num_rows>0) {
			$line = $rs->fetch_array( MYSQLI_ASSOC );
			if($line['cntgbid']<>NULL) {
				$count = $line['cntgbid'];
			}
		}

		return $count;

	}  // -- end of function


	private function getMaxGbID() {
		// global $this->config;

		$maxgbid = 1;

		// Query Statement
		$query = "SELECT max(gbID) as maxgbid FROM ".GB_TABLENAME;

		// Query ausführen....
		$rs = $this->dbQuery($query);

		//... und auswerten
		if($rs<>false and $rs->num_rows>0) {
			$line = $rs->fetch_array(MYSQLI_ASSOC);
			if($line['maxgbid']<>NULL) {
				$maxgbid = $line['maxgbid'];
			}
		}
		return $maxgbid;
	}

	// Löschen der IP-Adressen bei den Einträgen, die älter als "delete_ip_after"
	// Tage sind
	private function cleanupIP() {
	  $days = $this->config['ip_delete_after'];
	  $days = 60*60*24*$days;
	  $query = "UPDATE ".GB_TABLENAME
	    ." SET gbIP = NULL"
	    ." WHERE 1=1"
	    ." AND   gbWhen < (unix_timestamp() - ".$this->dbMes($days).")"
	    ." AND   gbIP is not null"
	  ;

	  $this->dbQuery($query);
	}


	//=============================================================================

	// html ---------------------------------------------------------------------

	/**
	 * HTML Seite mit 'head' und 'body' öffnen.
	*/
	private function html_open() {

		$html = "";

		if($this->config['is_html'] == false) {
			$this->js = $this->HTML_javascript();
		}

		$html .= ''
		  .(( $this->config['is_html'] == true)
			    ? "<!DOCTYPE html>\n"
  				 ."<head>\n"
  				 ."<meta charset=\"ISO-8859-1\">\n"
  				 ."<style type=\"text/css\">\n"
           ."<!--\n"
           .$this->css
           ."-->\n"
           ."</style>\n"
  				 .$this->HTML_javascript()
  			   ."</head>\n"
  				 ."<body>\n"
  				:''
  	  )
  	  .'<div id="XVW">'
  	  .(( strlen($this->config['headline'])>0 )
			    ? "<br><p class=\"headline\">".$this->config['headline']."</p>\n"
			    : ''
			)
			.(( strlen($this->config['headline_add'])>0 )
			    ? "<p class=\"headline-sub\">".$this->config['headline_add']."</p>\n"
			    : ''
			)
		;

		return $html;

	}  // -- end of function HTML_open()


	private function html_guestbook_offline() {
	  return $this->showErrMsg("Das G&auml;stebuch ist deaktiviert.");
	}


	/**
	 * HTML Seite schliessen (erst 'body' dann 'html').
	*/
	private function html_close() {
		// global $this->config;
		$html = "";

		$html .= ''
		  .'<br>' . CRLF
			.'<br>' . CRLF
			// .'<!-- ****************************** Start: Foot *************************** -->' . CRLF
			// .'<hr noshade size="1">' . CRLF
			.'<table class="footer" border="0" align="center" cellpadding="0" cellspacing="0">' . CRLF
			.'<tr>' . CRLF
			.'<td bgcolor="#B4B6B4" style="width:100%; text-align:center;"><small>Design und Umsetzung: VoiD'
			.', Download: <a href="http://www.void-web.de/guestbook-redirect.php"><b>www.void-web.de</b></a>'
			.', &copy; 2015, '.GUESTBOOK_VERSION
			.'</td>' . CRLF
			.'</tr>' . CRLF
			.'</table>' . CRLF
			// .'<!-- ****************************** Ende: Foot **************************** -->' . CRLF
			.'</div><!-- // XVW // -->' . CRLF

			.(($this->config['is_html'] == true)
			    ?  "</body>\n"
				    ."</html>\n"
				  : ''
			)
		;

		return $html;

	}  // eof ( HTML_close ) -- //



	private function html_javascript() {
		if ( $this->config['is_html'] ) {
			return ''
			  .'<script type="text/javascript">' . CRLF
				.'<!--' . CRLF
				.$this->html_javascript0()
				.'-->' . CRLF
				.'</script>' . CRLF
			;
		}
		else {
			return $this->html_javascript0();
		}
	}  // -- eof ( html_javascript ) -- //


	private function html_javascript0() {
	  return ''
			.'function addSmiley(gbMessage,sm) {' . CRLF
			.'  gbMessage.value = gbMessage.value + sm;' . CRLF
			.'}' . CRLF
		;
	}



	//=============================================================================

	// div ---------------------------------------------------------------------

  private function db2html($str) {
    if ( empty($str) == true ) {
      return $str;
    }
    return htmlspecialchars( $str, ENT_COMPAT , 'ISO-8859-1' );
  }


  private function html2db($str) {
    if ( empty($str) == true ) {
      return $str;
    }
    return str_replace( '&quot;' , '"', $str);
  }



	private function getUserIP() {
		$userIP = "";

		if(@isset($_SERVER["REMOTE_ADDR"])==true) {
			$userIP = $_SERVER["REMOTE_ADDR"];
		}

		return $userIP;
	}



	/**
	 * Zeigt eine Nachricht an.
	 *
	 * @param $message die darzustellende Nachricht
	 * @param $bgcolor (optional) Rahmenfarbe (und Farbe der ersten Zeile) der
	 *        Tabelle
	*/
	private function showErrMsg($message,$bgcolor=NULL) {
		return ''
		  .'<table border="0" align="center" cellpadding="0" cellspacing="1">' . CRLF
			.'<tr class="err-head">' . CRLF
			.'  <td align="center"><b>Es ist ein Fehler aufgetreten</b></td>' . CRLF
			.'</tr>' . CRLF
			.'<tr class="err-base">' . CRLF
			.'  <td align="left">'.$message.'</td>' . CRLF
			.'</tr>' . CRLF
			.'</table>' . CRLF
		;

	}  // -- end of function



	/**
	 * Prüft die eingegebenen Daten:
	 * - Name vorhanden
	 * - eMail-Adresse korrekt
	 * - HP korrekt
	 * - Nachricht vorhanden
	 *
	 * @param $gbName Benutzername
	 * @param $gbMail eMail-Adresse
	 * @param $gbHomepage Homepage
	 * @param $gbMessage Nachricht
	 *
	 * @return Leerstring, wenn kein Fehler aufgetreten ist, ansonsten die
	 *         Fehlerbschreibung
	*/
	private function checkData($gbName,$gbMail,$gbHomepage,$gbMessage) {
		$error = "";

		// Name angegeben?
		if(strcmp($gbName,"")==0) {
			$error .= "<b>&raquo;</b> Das Feld \"Name\" muss ausgef&uuml;llt sein.";
		}

		// eMail-Adresse korrekt
		if (strlen($gbMail)>0 and (preg_match ("/^(
			([a-z0-9]{1}[a-z0-9_.-]+[a-z0-9]{1})
			[@]{1}
			([a-z0-9]{1}[a-z0-9.-]+[a-z0-9]{1})[.]{1}([a-z]{2}|com|net|edu|org|gov|mil|int|biz|pro|info|arpa|aero|coop|name|museum)
			)$/ix", $gbMail)) == false) {

			if(strlen($error)>0) $error .= "\n<br>";
			$error .= "<b>&raquo;</b> Die e-Mailadresse ist ungültig.";
		}

		// Homepage korrekt
		if(strlen($gbHomepage)>0
			and preg_match("#^((http(s)?|ftp|news)://)+[a-z\d\.@_-]*[a-z\d@_-]+\.([a-z]{2}|aero|arpa|biz|com|coop|edu|gov|info|int|mil|museum|name|net|org|pro|shop)[a-z\d@\/\%\#\~\.\?=&,;_-]*$#i",$gbHomepage)==false) {
			if(strlen($error)>0) $error .= "\n<br>";
			$error .= "<b>&raquo;</b> Die Angabe bei \"Homepage\" erscheint unrichtig.";
		}

		// Nachricht ok?
		if(strcmp($gbMessage,"")==0) {
			if(strlen($error)>0) $error .= "\n<br>";
			$error .= "<b>&raquo;</b> Das Feld \"Nachricht\" muss ausgef&uuml;llt sein.";
		}


    // Längen eingehalten?
    if ( strlen($gbName) > 40 ) {
			$error .= "<b>&raquo;</b> Das Name ist zu lang.";
		}
    if ( strlen($gbMail) > 80 ) {
			$error .= "<b>&raquo;</b> Die EMail-Adresse ist zu lang.";
		}
    if ( strlen($gbHomepage) > 80 ) {
			$error .= "<b>&raquo;</b> Die Angabe zur Homepage ist zu lang.";
		}
    if ( strlen($gbMessage) > $this->config['max_post_length'] ) {
			$error .= "<b>&raquo;</b> Der Nachrichtentext ist zu lang.";
		}


    // diese Begriffe werden als Platzhalter in den Mails verwendet und können
    // nicht in dem Gästebuch verwendet werden.
    $reserved = array
    ( "##POST_ID##"
    , "##POST_NAME##"
    , "##POST_DATE##"
    , "##POST_MAIL##"
    , "##POST_HOMEPAGE##"
    , "##POST_IP##"
    , "##POST_MESSAGE##"

    , "##MAIL_DYN_SERVER##"
    , "##MAIL_DYN_LINK##"
    );


    foreach($reserved as $v) {
      if (strpos($gbName,strToLower($v)) !== false or strpos($gbName,strToUpper($v)) !== false) {
        $error .= "<br><b>&raquo;</b> Der Name enthält eine ungültige Eintragung.";
      }

      if (strpos($gbMail,strToLower($v)) !== false or strpos($gbMail,strToUpper($v)) !== false) {
        $error .= "<br><b>&raquo;</b> Die E-Mailadresse enthält eine ungültige Eintragung.";
      }

      if (strpos($gbHomepage,strToLower($v)) !== false or strpos($gbHomepage,strToUpper($v)) !== false) {
        $error .= "<br><b>&raquo;</b> Die Homepage enthält eine ungültige Eintragung.";
      }

      if (strpos($gbMessage,strToLower($v)) !== false or strpos($gbMessage,strToUpper($v)) !== false) {
        $error .= "<br><b>&raquo;</b> Der Nachricht enthält eine ungültige Eintragung.";
      }
    }

    // Kein Zugriff auf die Konfigurationsparameter
    foreach(array_keys($this->config) as $k) {
      if (strpos($gbName,'##'.strToLower($k).'##') !== false or strpos($gbName,'##'.strToUpper($k).'##') !== false) {
        $error .= "<br><b>&raquo;</b> Der Name enthält eine ungültige Eintragung.";
      }

      if (strpos($gbMail,'##'.strToLower($k).'##') !== false or strpos($gbMail,'##'.strToUpper($k).'##') !== false) {
        $error .= "<br><b>&raquo;</b> Die E-Mailadresse enthält eine ungültige Eintragung.";
      }

      if (strpos($gbHomepage,'##'.strToLower($k).'##') !== false or strpos($gbHomepage,'##'.strToUpper($k).'##') !== false) {
        $error .= "<br><b>&raquo;</b> Die Homepage enthält eine ungültige Eintragung.";
      }

      if (strpos($gbMessage,'##'.strToLower($k).'##') !== false or strpos($gbMessage,'##'.strToUpper($k).'##') !== false) {
        $error .= "<br><b>&raquo;</b> Der Nachricht enthält eine ungültige Eintragung.";
      }
    }


		return $error;

	}  // -- end of function


	/**
	 * Prüft die Angabe zu "Erstelldatum".
	 *
	 * Diese Prüfung ist nur für den UPDATE Vorgang notwendig.
	*/
	private function checkDatum($error,$dd="",$mon="",$yyyy="",$hh="",$mm="") {

		if((strlen($dd)==0 or $dd==-1)
			and (strlen($mon)==0 or $mon==-1)
			and strlen($yyyy)==0
			and strlen($hh)==0
			and strlen($mm)==0) {
			return $error;
		}

		// mindests eine Datum-/Uhrzeitangabe ist gesetzt
		else {
			// Angabe zum Tag überprüfen (-1=Leerstring)
			if(strlen($dd)==0)               $error .= (strlen($error)>0 ? "\n<br>" : "")."<b>&raquo;</b> Die Angabe zum Tag fehlt.";
			else if($dd=="-1")               $error .= (strlen($error)>0 ? "\n<br>" : "")."<b>&raquo;</b> Die Angabe zum Tag fehlt.";
			else if(strlen($dd)>2)           $error .= (strlen($error)>0 ? "\n<br>" : "")."<b>&raquo;</b> Die Angabe zum Tag ist fehlerhaft.";
			else if(!$this->isNumber($dd))   $error .= (strlen($error)>0 ? "\n<br>" : "")."<b>&raquo;</b> Die Angabe zum Tag ist fehlerhaft (alphanumerisches Zeichen enthalten?).";
			else if($dd<1 or $dd>31)         $error .= (strlen($error)>0 ? "\n<br>" : "")."<b>&raquo;</b> Die Angabe zum Tag ist fehlerhaft.";

			// Angabe zum Monat überprüfen (-1=Leerstring)
			if(strlen($mon)==0)              $error .= (strlen($error)>0 ? "\n<br>" : "")."<b>&raquo;</b> Die Angabe zum Monat fehlt.";
			else if($mon=="-1")              $error .= (strlen($error)>0 ? "\n<br>" : "")."<b>&raquo;</b> Die Angabe zum Monat fehlt.";
			else if(strlen($mon)>2)          $error .= (strlen($error)>0 ? "\n<br>" : "")."<b>&raquo;</b> Die Angabe zum Monat fehlerhaft.";
			else if(!$this->isNumber($mon))  $error .= (strlen($error)>0 ? "\n<br>" : "")."<b>&raquo;</b> Die Angabe zum Monat ist fehlerhaft (alphanumerisches Zeichen enthalten?).";
			else if($mon<1 or $mon>12)       $error .= (strlen($error)>0 ? "\n<br>" : "")."<b>&raquo;</b> Die Angabe zum Monat ist fehlerhaft.";

			// Angabe zum Jahr überprüfen
			if(strlen($yyyy)==0)             $error .= (strlen($error)>0 ? "\n<br>" : "")."<b>&raquo;</b> Die Angabe zum Jahr fehlt.";
			else if(strlen($yyyy)<>4)        $error .= (strlen($error)>0 ? "\n<br>" : "")."<b>&raquo;</b> Die Angabe zum Jahr ist fehlerhaft.";
			else if(!$this->isNumber($yyyy)) $error .= (strlen($error)>0 ? "\n<br>" : "")."<b>&raquo;</b> Die Angabe zum Jahr ist fehlerhaft (alphanumerisches Zeichen enthalten?).";

			// Angabe zu den Stunden überprüfen
			if(strlen($hh)==0)               $error .= (strlen($error)>0 ? "\n<br>" : "")."<b>&raquo;</b> Die Stundenangebe fehlt.";
			else if(strlen($hh)>2)           $error .= (strlen($error)>0 ? "\n<br>" : "")."<b>&raquo;</b> Die Stundenangebe ist fehlerhaft.";
			else if(!$this->isNumber($hh))   $error .= (strlen($error)>0 ? "\n<br>" : "")."<b>&raquo;</b> Die Stundenangebe ist fehlerhaft (alphanumerisches Zeichen enthalten?).";
			else if($hh<0 or $hh>23)         $error .= (strlen($error)>0 ? "\n<br>" : "")."<b>&raquo;</b> Die Stundenangebe ist fehlerhaft.";

			// Angabe zu den Minuten überprüfen
			if(strlen($mm)==0)               $error .= (strlen($error)>0 ? "\n<br>" : "")."<b>&raquo;</b> Die Minutenangabe fehlt.";
			else if(strlen($mm)>2)           $error .= (strlen($error)>0 ? "\n<br>" : "")."<b>&raquo;</b> Die Minutenangabe ist fehlerhaft.";
			else if(!$this->isNumber($mm))   $error .= (strlen($error)>0 ? "\n<br>" : "")."<b>&raquo;</b> Die Minutenangabe ist fehlerhaft (alphanumerisches Zeichen enthalten?).";
			else if($mm<0 or $mm>59)         $error .= (strlen($error)>0 ? "\n<br>" : "")."<b>&raquo;</b> Die Minutenangabe ist fehlerhaft.";
		}

		return $error;
	}



	private function createDatum($dd,$mon,$yyyy,$hh,$mm,$ss=0) {
		$when = 0;
		if(   $this->isNumber($dd)   and $dd>=1      and $dd<=31
			and $this->isNumber($mon)  and $mon>=1     and $mon<=12
			and $this->isNumber($yyyy) and $yyyy>=1990 and $yyyy<=9999
			and $this->isNumber($hh)   and $hh>=0      and $hh<=23
			and $this->isNumber($mm)   and $mm>=0      and $mm<=59
			and $this->isNumber($ss)   and $ss>=0      and $ss<=59)
		{
			// mktime(hh,mm,ss,mon,day,year);
			$when = mktime($hh,$mm,$ss,$mon,$dd,$yyyy);
		}
		return $when;
	}


	/**
	 * Prüft ob der String eine numerische Angabe ist.
	 *
	 * @param $s der zu untersuchende String
	 * @return true, wenn der String numerisch ist ansonsten false
	*/
	private function isNumber($s) {
		if (!preg_match("/^\d+$/",$s)) {
			return false;
		}
		return true;
	}




	/**
	 * Anzeigen der "Navigations Bar".
	 * Ermöglicht das Navigieren durch die einzelnen Seiten des Gästebuchs
	 *
	 * @param $count die Anzahl an Posts insgesamt
	 * @param $page die aktuell selektierte Seite
	 * @param $perpage die Anzahl der Post, die je Seite dargestellt werden
	 *        sollen
	 * @param $linkparams Zusätzliche Parameter, die an die Links angehängt
	 *        werden sollen ($page und $perpage sind per default Bestandteil des
	 *        erzeugten Links, brauchen also NICHT angegeben werden).
	 * @param $showwhat soll dargestellt werden, was gerade im Gästebuch angezeigt
	 *        wird: "Zeige Einträge xx bis yy von zz", dann 1 angeben
	*/
	private function navigationBar($count,$page,$perpage,$parms=NULL,$showwhat=0) {
		$html     = "";
		$navRange = $this->config['navigation_range'];

		$sr = array
		( '[count]'   => $count
		, '[page]'    => $page
		, '[perpage]' => $perpage
		, '[startindex]' => (($page-1)*$perpage+1)
		, '[endindex]'   => min($page*$perpage,$count)
		);


    // ...für einfache Ersetzung
		$prevPage  = '&laquo; Vorherige Seite';
		$nextPage  = 'Nächste Seite &raquo;';
		$showPages = 'Einträge <b>[startindex]</b> bis <b>[endindex]</b> von <b>[count]</b>';



		if ( is_null($parms) == true ) {
		  $parms = array();
		}

		// Anzahl geringer als 'perpage'
		if($count <= $perpage) {
			if($showwhat==1) {
				return ''
				  .'<table class="xvw-navigation xvw-width" border="0" align="center">' . CRLF
					.'<tr>' . CRLF
					.'  <td style="text-align:center;" width="100%">'
					.str_replace(array_keys($sr),array_values($sr),$showPages)
					.'</td>' . CRLF
					.'</tr>' . CRLF
					.'</table>' . CRLF
			  ;
			}
			return '';
		}


		$maxpage = ceil($count / $perpage);

		$minNav = max($page-$navRange,1);           // max($page-5,1);
		$maxNav = min($maxpage,$page+$navRange);    // min($maxpage,$page+5);


	  $html .= ''
		  .'<table class="xvw-navigation xvw-width" border="0" align="center" cellpadding="0" cellspacing="0">' . CRLF
		  .'<tr>' . CRLF
		  .'  <td style="text-align:left;" width="25%" nowrap="nowrap">'
		  .'<b>Seite:</b>&nbsp'
		;

		// Um eine Seite nach links "verschieben"
		if($minNav > 1) {
			$html .= '<a href="'.$this->navHREF($parms,($page-1),$perpage).'">&laquo;</a>';
		}

		// Die einzelnen Seiten darstellen (ist aber begrenzt)
		for($i=$minNav; $i<=$maxNav; $i++) {
			if($i<>$page) {
				$html .= '<a href="'.$this->navHREF($parms,$i,$perpage).'">['.$i.']</a>';
			}
			else {
				$html .= '<b>['.$i.']</b>';   // <small>&nbsp;</small>';
			}
			$html .= CRLF;
		}

		// Um eine Seite nach rechts "verschieben"
		if($maxNav < $maxpage) {
			$html .= '<a href="'.$this->navHREF($parms,($page+1),$perpage).'">&raquo;</a>';
		}

		$html .= ''
	  	.'</td>' . CRLF
	  	.'<td style="text-align:center;" width="50%" nowrap="nowrap">'
		  .($showwhat==1
		      ? str_replace(array_keys($sr),array_values($sr),$showPages)
		      : ''
		   )
			.'</td>' . CRLF
		  .'<td style="text-align:right;" width="25%" nowrap="nowrap">'
			.(($page > 1)
			    ? '<a href="'.$this->navHREF($parms,($page-1),$perpage).'">'.$prevPage.'</a>'
			    : $prevPage
			 )
			.'&nbsp;|&nbsp;'
			.(($page < $maxpage)
			    ? '<a href="'.$this->navHREF($parms,($page+1),$perpage).'">'.$nextPage.'</a>'
			    : $nextPage
			 )
			.'</td>' . CRLF
		  .'</tr>' . CRLF
		  .'</table>' . CRLF
		;

		return $html;

	}  // -- end of function


	/***
	 * Baut den HREF für die Navigation
	***/
	private function navHREF( $parms , $p , $pp) {
	  if ( is_array($parms) == false) {
	    $parms = array();
	  }

	  $parms[ 'p'  ] = $p;
	  $parms[ 'pp' ] = $pp;
	  return $this->getHREF($parms);
	}


	private function getHREF( $parms ) {
	  // global $this->config;

	  $p   = "";

	  // externe Parameter einbauen
	  if (     array_key_exists('external_params',$this->config) == true
	      and is_array($this->config['external_params']) == true
	     )
	  {
	    foreach( $this->config['external_params'] as $k => $v) {
	      $p .= ((strlen($p)>0) ? "&" : "?") . $k . "=" . $v;
	    }
	  }

	  // $parms
	  if (is_array($parms) == true and count($parms) > 0)
	  {
	    foreach( $parms as $k => $v) {
	      $p .= ((strlen($p)>0) ? "&" : "?") . $k . "=" . $v;
	    }
	  }

	  return $this->config['phpself'] . $p;

	}


	private function getMailLink()
	{
	  $addr     = "";
	  $httpHost = ((array_key_exists('HTTP_HOST',$_SERVER)==true) ? $_SERVER['HTTP_HOST'] : '');
	  $srvAddr  = ((array_key_exists('SERVER_ADDR',$_SERVER)==true) ? $_SERVER['SERVER_ADDR'] : '');
	  $srvPort  = ((array_key_exists('SERVER_PORT',$_SERVER)==true) ? $_SERVER['SERVER_PORT'] : '');

	  if ( strlen($srvAddr) > 0 ) {
	    $addr  = "http://".$srvAddr;
	    $addr .= ((strlen($srvPort)>0 and strcmp($srvPort,"80")<>0) ? ":".$srvPort : "");
	    $addr .= ((strlen($this->config['mail_link']) > 0) ? $this->config['mail_link'] : $this->config['phpself']);
	  }
	  else if ( strlen($httpHost) > 0) {
	    $addr  = "http://".$httpHost;
	    $addr .= ((strlen($this->config['mail_link']) > 0) ? $this->config['mail_link'] : $this->config['phpself']);
	  }
	  else {
	    $addr = ((strlen($this->config['mail_link']) > 0) ? $this->config['mail_link'] : $this->config['phpself']);
	  }
	  return $addr;
	}


	private function gbFind($key,$default="") {
	  if(isset($_GET[$key]) && $_GET[$key] != '') {
	     return $_GET[$key];
	  }
	  if(isset($_POST[$key]) && $_POST[$key] != '') {
	    return $_POST[$key];
	  }
	  if(isset($_SESSION[$key]) && $_SESSION[$key] != '') {
	  	return $_SESSION[$key];
	  }

	  return $default;
	}

}  // -- eoc ( XVW_Guestbook ) -- //



?>